package com.gyee.alarm.service.auto.impl;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.gyee.alarm.init.CacheContext;
import com.gyee.alarm.model.auto.ProEconAlarmConfiguration;
import com.gyee.alarm.mapper.auto.ProEconAlarmConfigurationMapper;
import com.gyee.alarm.model.vo.AlarmTypeValue;
import com.gyee.alarm.model.vo.AlarmVo;

import com.gyee.alarm.service.AlarmBtService;
import com.gyee.alarm.service.AlarmInService;
import com.gyee.alarm.service.AlarmWtService;
import com.gyee.alarm.service.auto.IProEconAlarmConfigurationService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

/**
 * <p>
 * 报警配置表 服务实现类
 * </p>
 *
 * @author shilin
 * @since 2023-06-19
 */
@Service
public class ProEconAlarmConfigurationServiceImpl extends ServiceImpl<ProEconAlarmConfigurationMapper, ProEconAlarmConfiguration> implements IProEconAlarmConfigurationService {

    @Resource
    private  ProEconAlarmConfigurationMapper proEconAlarmConfigurationMapper;

    public IPage<ProEconAlarmConfiguration> pageQueryAll(Page page,
                                                         String description,
                                                         String wpId,
                                                         String modelId,String alarmType)
    {
        IPage<ProEconAlarmConfiguration> pages=  proEconAlarmConfigurationMapper.pageQueryAll(page,
                description,
                wpId,
                modelId, alarmType);

        return pages;
    }


    @Resource
    private AlarmWtService alarmWtService;
    @Resource
    private AlarmInService alarmInService;
    @Resource
    private AlarmBtService alarmBtService;
    public void inital() throws Exception {


        List<ProEconAlarmConfiguration> templs =this.list().stream().filter(i -> i.getEnable()).collect(Collectors.toList());
        if (!templs.isEmpty()) {
            for (ProEconAlarmConfiguration alarm : templs) {
                if (alarm.getAlarmType().equals(AlarmTypeValue.WT.getCode())) {
                    CacheContext.wtalarmls.add(alarm);
                    StringBuilder sb=new StringBuilder();
                    sb.append(alarm.getStationId()).append(alarm.getModelId());

                    if(CacheContext.wtAlarmMap.containsKey(String.valueOf(sb)))
                    {
                        List<ProEconAlarmConfiguration> ls=CacheContext.wtAlarmMap.get(String.valueOf(sb));
                        ls.add(alarm);
                    }else
                    {
                        List<ProEconAlarmConfiguration> ls=new ArrayList<>();
                        ls.add(alarm);
                        CacheContext.wtAlarmMap.put(String.valueOf(sb),ls);
                    }
                } else if (alarm.getAlarmType().equals(AlarmTypeValue.BT.getCode())) {
                    CacheContext.btalarmls.add(alarm);

                }
                else if (alarm.getAlarmType().equals(AlarmTypeValue.IN.getCode())) {
                    CacheContext.inalarmls.add(alarm);
                    StringBuilder sb=new StringBuilder();
                    sb.append(alarm.getStationId()).append(alarm.getModelId());

                    if(CacheContext.inAlarmMap.containsKey(String.valueOf(sb)))
                    {
                        List<ProEconAlarmConfiguration> ls=CacheContext.inAlarmMap.get(String.valueOf(sb));
                        ls.add(alarm);
                    }else
                    {
                        List<ProEconAlarmConfiguration> ls=new ArrayList<>();
                        ls.add(alarm);
                        CacheContext.inAlarmMap.put(String.valueOf(sb),ls);
                    }
                }
            }
        }

        //风机报警初始化标签
        CacheContext.alarmWtList=alarmWtService.initalAlarmVo();
        if(!CacheContext.alarmWtList.isEmpty())
        {
            for(AlarmVo vo: CacheContext.alarmWtList)
            {

                CacheContext.alarmWtMap.put(vo.getTbName().toUpperCase(),vo);

                if(CacheContext.alarmWtLsMap.containsKey(vo.getStationid()))
                {
                    List<AlarmVo> ls=CacheContext.alarmWtLsMap.get(vo.getStationid());
                    ls.add(vo);
                }else {
                    List<AlarmVo> ls=new ArrayList<>();
                    ls.add(vo);
                    CacheContext.alarmWtLsMap.put(vo.getStationid(),ls);
                }
            }
        }
        //逆变器报警初始化标签
        CacheContext.alarmInList=alarmInService.initalAlarmVo();
        if(!CacheContext.alarmInList.isEmpty())
        {
            for(AlarmVo vo: CacheContext.alarmInList)
            {
                CacheContext.alarmInMap.put(vo.getTbName().toUpperCase(),vo);

                if(CacheContext.alarmInLsMap.containsKey(vo.getStationid()))
                {
                    List<AlarmVo> ls=CacheContext.alarmInLsMap.get(vo.getStationid());
                    ls.add(vo);
                }else {
                    List<AlarmVo> ls=new ArrayList<>();
                    ls.add(vo);
                    CacheContext.alarmInLsMap.put(vo.getStationid(),ls);
                }
            }
        }


        //升压站报警初始化标签
        CacheContext.alarmBtList=alarmBtService.initalAlarmVo();
        if(!CacheContext.alarmBtList.isEmpty())
        {
            for(AlarmVo vo: CacheContext.alarmBtList)
            {
                CacheContext.alarmBtMap.put(vo.getTbName().toUpperCase(),vo);

                if(CacheContext.alarmBtLsMap.containsKey(vo.getStationid()))
                {
                    List<AlarmVo> ls=CacheContext.alarmBtLsMap.get(vo.getStationid());
                    ls.add(vo);
                }else {
                    List<AlarmVo> ls=new ArrayList<>();
                    ls.add(vo);
                    CacheContext.alarmBtLsMap.put(vo.getStationid(),ls);
                }
            }
        }
    }

}

